import os
import sys

if len(sys.argv) <= 1:
    print('Usage: python autosiesta.py SystemLabel')
    sys.exit()

label = sys.argv[1]

f_fdf = open(label + '.fdf', 'r')  
f_in = open(label + '.in', 'r')  
f_out = open(label + '.script.out', 'w')  

par = []  
count = []  
currentPar = []  

ipar = 0  
Nsiestas = 1.0  

line = f_in.readline()
while line:
    if line.startswith('#'):
        line = f_in.readline()
    else:
        par.append([])
        parts = line.split()
        par[ipar].append(parts[0])  # Label of the parameter
        par[ipar].append(float(parts[1]))  # Min
        par[ipar].append(float(parts[2]))  # Max
        par[ipar].append(int(parts[3]))  # Steps
        disp = (par[ipar][2] - par[ipar][1]) / par[ipar][3]
        par[ipar].append(disp)  # Displacement
        ipar = ipar + 1
        Nsiestas = Nsiestas * (float(parts[3]) + 1)
        count.append(0)
        currentPar.append(float(parts[1]))
        line = f_in.readline()

Npar = ipar  
print('Total calls to SIESTA = ' + str(Nsiestas))
siesta_call = 1
control = True
MeshCutoff = False

f_tmp = open(label + '.' + str(siesta_call) + '.tmp', 'w')  

line = f_fdf.readline()
while line:
    parts = line.split()
    for k in range(0, len(parts)):
        for m in range(0, Npar):
            if parts[k].lower() == par[m][0].lower():
                parts[k] = str(currentPar[m])
                if parts[0].lower() == 'meshcutoff':
                    MeshCutoff = True
                    ExtraLabel = 'MeshCutoff used'

    line = ' '.join(parts)
    f_tmp.write(line + '\n')
    line = f_fdf.readline()

f_tmp.close()
f_fdf.seek(0)
print('SIESTA call number ', str(siesta_call))
os.system('./siesta < ' + label + '.' + str(siesta_call) + '.tmp' + ' > ' + label + '.' + str(
    siesta_call) + '.out')

f_out.write('##')
for n in range(0, Npar):
    f_out.write('%20s ' % par[n][0][1:])
if MeshCutoff:
    f_out.write('%20s ' % ExtraLabel)
f_out.write('%20s ' % 'Etot')
f_out.write('%15s ' % 'Fmax\n')

f_out.write(' ')
for n in range(0, Npar):
    f_out.write('%20s ' % str(currentPar[n]))
f_siestaOut = open(label + '.' + str(siesta_call) + '.out', 'r')

line = f_siestaOut.readline()
while line:
    parts = line.split()
    if MeshCutoff:
        if line[0:21] == 'InitMesh: Mesh cutoff':
            f_out.write('%20s ' % parts[7])
    if len(parts) == 3:
        if parts[2] == 'constrained':
            Fmax = parts[1]
    if len(parts) == 4:
        if parts[1] == 'Etot':
            Etot = parts[3]
    line = f_siestaOut.readline()

f_out.write('%20s ' % Etot)
f_out.write('%15s ' % Fmax)
f_out.write('\n')

f_siestaOut.close()
siesta_call = siesta_call + 1

while control:
    count[0] = count[0] + 1
    currentPar[0] = currentPar[0] + par[0][4]

    f_tmp = open(label + '.' + str(siesta_call) + '.tmp', 'w')  

    line = f_fdf.readline()
    while line:
        parts = line.split()
        for k in range(0, len(parts)):
            for m in range(0, Npar):
                if parts[k].lower() == par[m][0].lower():
                    parts[k] = str(currentPar[m])

        line = ' '.join(parts)
        f_tmp.write(line + '\n')
        line = f_fdf.readline()

    f_tmp.close()
    f_fdf.seek(0)
    print('SIESTA call number ', str(siesta_call))
    os.system('./siesta < ' + label + '.' + str(siesta_call) + '.tmp' + ' > ' + label + '.' + str(
        siesta_call) + '.out')

    f_out.write('  ')
    for n in range(0, Npar):
        f_out.write('%20s ' % str(currentPar[n]))
    f_siestaOut = open(label + '.' + str(siesta_call) + '.out', 'r')

    line = f_siestaOut.readline()
    while line:
        parts = line.split()
        if MeshCutoff:
            if line[0:21] == 'InitMesh: Mesh cutoff':
                f_out.write('%20s ' % parts[7])
        if len(parts) == 3:
            if parts[2] == 'constrained':
                Fmax = parts[1]
        if len(parts) == 4:
            if parts[1] == 'Etot':
                Etot = parts[3]
        line = f_siestaOut.readline()

    f_out.write('%20s ' % Etot)
    f_out.write('%15s ' % Fmax)
    f_out.write('\n')

    siesta_call = siesta_call + 1
    f_siestaOut.close()

    for j in range(0, Npar):
        if count[j] == par[j][3]:
            if j == (Npar - 1):
                control = False
            elif count[j + 1] != par[j + 1][3]:
                count[j + 1] = count[j + 1] + 1
                count[j] = 0
                currentPar[j + 1] = currentPar[j + 1] + par[j + 1][4]
                currentPar[j] = par[j][1]

                f_tmp = open(label + '.' + str(siesta_call) + '.tmp', 'w')
                line = f_fdf.readline()
                while line:
                    parts = line.split()
                    for k in range(0, len(parts)):
                        for m in range(0, Npar):
                            if parts[k].lower() == par[m][0].lower():
                                parts[k] = str(currentPar[m])

                    line = ' '.join(parts)
                    f_tmp.write(line + '\n')
                    line = f_fdf.readline()

                f_tmp.close()
                f_fdf.seek(0)
                print('SIESTA call number ', str(siesta_call))
                os.system('./siesta < ' + label + '.' + str(siesta_call) + '.tmp' + ' > ' + label + '.' + str(
                    siesta_call) + '.out')

                f_out.write('  ')
                for n in range(0, Npar):
                    f_out.write('%20s ' % str(currentPar[n]))
                f_siestaOut = open(label + '.' + str(siesta_call) + '.out', 'r')

                line = f_siestaOut.readline()
                while line:
                    parts = line.split()
                    if MeshCutoff:
                        if line[0:21] == 'InitMesh: Mesh cutoff':
                            f_out.write('%20s ' % parts[7])
                    if len(parts) == 3:
                        if parts[2] == 'constrained':
                            Fmax = parts[1]
                    if len(parts) == 4:
                        if parts[1] == 'Etot':
                            Etot = parts[3]
                    line = f_siestaOut.readline()

                f_out.write('%20s ' % Etot)
                f_out.write('%15s ' % Fmax)
                f_out.write('\n')
                siesta_call = siesta_call + 1
                f_siestaOut.close()
                break
            elif count[j + 1] == par[j + 1][3]:
                count[j] = 0
                currentPar[j] = par[j][1]

f_fdf.close()
f_in.close()
f_out.close()

print('The End')
sys.exit()

